using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ReadXMLTest
{
    public partial class frmMain : Form
    {
        public frmMain()
        {
            InitializeComponent();
        }

        private void btnLoadTable_Click(object sender, EventArgs e)
        {
            // create unbound recordset for temporary storage (from Paradox table)
            DataTable table1 = new DataTable("country");
            table1.Columns.Add("Name");
            table1.Columns.Add("Capital");
            table1.Columns.Add("Continent");
            table1.Columns.Add("Area");
            table1.Columns.Add("Population");
            table1.Rows.Add("Ukraine", "Kiev", "Europe", 0, 45000000);
            table1.Rows.Add("France", "Paris", "Europe", 0, 0);

            DataSet set = new DataSet("map");
            set.Tables.Add(table1);

            // convert the records in Paradox table to xml-file
            PdxViewA.TScalabiumParadoxReader pdx = new PdxViewA.TScalabiumParadoxReader();
            pdx.FileName = Application.StartupPath + "\\country.db";
            pdx.SaveToXML(Application.StartupPath + "\\country.xml", "country", false);
            if (pdx.LastErrorMessage != null)
                MessageBox.Show(pdx.LastErrorMessage);

            //load converted xml into dataset
            set.ReadXml(Application.StartupPath + "\\country.xml");

            //view records in datagrid
            dataGridView1.DataSource = table1;

            string strSchema = set.GetXmlSchema();
            MessageBox.Show(strSchema);

            string strXML = set.GetXml();
            MessageBox.Show(strXML);
        }
    }
}