unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, Db, ADODB, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    ADOConnection1: TADOConnection;
    ADOTable1: TADOTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    btnLoad: TButton;
    rgLoadMode: TRadioGroup;
    btnSaveToCSV: TButton;
    btnSaveToSQL: TButton;
    btnSaveToXML: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnLoadClick(Sender: TObject);
    procedure btnSaveToCSVClick(Sender: TObject);
    procedure btnSaveToSQLClick(Sender: TObject);
    procedure btnSaveToXMLClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R winxp.res}
{$R *.DFM}
uses ComObj, Variants;

const
  sfSQL92 = $00000000;
  sfOracle = $00000001;
  sfMSSQL = $00000002;
  sfPostgres = $00000003;
  sfMySQL = $00000004;
  sfInterbase = $00000005;
  sfDB2 = $00000006;
  sfMSAccess = $00000007;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ADOConnection1.Connected := True;
  ADOTable1.Open;
end;

procedure TForm1.btnLoadClick(Sender: TObject);
const
  imAppend = $00000000;
  imUpdate = $00000001;
  imAppendUpdate = $00000002;
  imDelete = $00000003;
  imCopy = $00000004;
  imAppendNewOnly = $00000005;

var
  pdx: Variant;
begin
  pdx := CreateOleObject('PdxViewA.TScalabiumParadoxReader');

//  pdx.Filter := '(SUBSTRING(Name, 1, 1) = ''A'') OR (Area > 100000)';

  pdx.FileName := ExtractFilePath(Application.ExeName) + '\country.db';
  case rgLoadMode.ItemIndex of
    0: pdx.Mode := imAppend;
    1: pdx.Mode := imUpdate;
    2: pdx.Mode := imAppendUpdate;
    3: pdx.Mode := imDelete;
    4: pdx.Mode := imCopy;
    5: pdx.Mode := imAppendNewOnly;
  end;
  pdx.UniqueFields := 'NAME';
//  pdx.FirstRow := 10;

  ADOTable1.DisableControls;
  try
    pdx.LoadToRecordset(ADOTable1.Recordset);
    ADOTable1.Close;
    ADOTable1.Open;
  finally
    ADOTable1.EnableControls;
  end;

  if (pdx.LastErrorMessage = '') then
    ShowMessage('Data succesfully loaded')
  else
    ShowMessage(pdx.LastErrorMessage);

  pdx := UnAssigned;
end;

procedure TForm1.btnSaveToCSVClick(Sender: TObject);
var
  pdx: Variant;
begin
  pdx := CreateOleObject('PdxViewA.TScalabiumParadoxReader');
  try
    pdx.FileName := ExtractFilePath(Application.ExeName) + '\country.db';
    pdx.SaveToCSV(ExtractFilePath(Application.ExeName) + '\country.csv', ',', '"', 1);
    ShowMessage('Data succesfully converted to CSV-file')
  finally
    pdx := UnAssigned;
  end;
end;

procedure TForm1.btnSaveToSQLClick(Sender: TObject);
var
  pdx: Variant;
begin
  pdx := CreateOleObject('PdxViewA.TScalabiumParadoxReader');
  try
    pdx.FileName := ExtractFilePath(Application.ExeName) + '\country.db';
    pdx.SQLFormat := sfMSSQL;
    pdx.SaveToSQL(ExtractFilePath(Application.ExeName) + '\country.sql', 'country', 1);
    ShowMessage('Data succesfully converted to SQL-dump')
  finally
    pdx := UnAssigned;
  end;
end;

procedure TForm1.btnSaveToXMLClick(Sender: TObject);
var
  pdx: Variant;
begin
  pdx := CreateOleObject('PdxViewA.TScalabiumParadoxReader');
  try
    pdx.FileName := ExtractFilePath(Application.ExeName) + '\country.db';
    pdx.SQLFormat := sfMSSQL;
    pdx.SaveToXML(ExtractFilePath(Application.ExeName) + '\country.xml', 'country', 1);
    ShowMessage('Data succesfully converted to xml-file')
  finally
    pdx := UnAssigned;
  end;
end;

end.
